package ink.wgink.gateway.component;

import ink.wgink.gateway.dao.route.IRouteDao;
import ink.wgink.gateway.handler.route.RouteHandler;
import ink.wgink.gateway.util.UUIDUtil;
import org.springframework.cloud.client.ServiceInstance;
import org.springframework.cloud.client.loadbalancer.*;
import org.springframework.cloud.gateway.handler.predicate.PredicateDefinition;
import org.springframework.cloud.gateway.route.RouteDefinition;
import org.springframework.cloud.gateway.route.RouteDefinitionRepository;
import org.springframework.cloud.gateway.route.RouteLocator;
import org.springframework.stereotype.Component;
import org.springframework.web.util.UriComponents;
import org.springframework.web.util.UriComponentsBuilder;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: RouteDefinitionRepository
 * @Description: 路由定义
 * @Author: wanggeng
 * @Date: 2021/4/22 4:04 下午
 * @Version: 1.0
 */
@Component
public class MongoRouteDefinitionRepository implements RouteDefinitionRepository {

    public RouteHandler routeHandler;

    public MongoRouteDefinitionRepository(RouteHandler routeHandler) {
        this.routeHandler = routeHandler;
    }

    @Override
    public Flux<RouteDefinition> getRouteDefinitions() {
        return routeHandler.routeDefinitionFlux();
    }

    @Override
    public Mono<Void> save(Mono<RouteDefinition> route) {
        return null;
    }

    @Override
    public Mono<Void> delete(Mono<String> routeId) {
        return null;
    }
}
